/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 * ͒PĳUARTp̗łB
 *
 * ްMACR($0D)MA܂ްz񂪈t̎ɑԂ
 * ܂B
 *
 * \par pLq:
 * AVR274 : PĳUART
 *
 * \par 
 * IȺގAxׁ߲A߲אݒAx޲ɂĂ
 * readme.htmlB
 *
 * \author
 *      Atmel Corporation: http://www.atmel.com \n
 *      xEҰ: avr@atmel.com
 *
 * $Name:  $
 * $Revision: 1222 $
 * $RCSfile: main.c,v $
 * $Date: 2006N1114 17:32:38 +0100 $  \n
 ******************************************************************************/

#include "single_wire_UART.h"
#include <ioavr.h>
#include <inavr.h>
#include "Common_Define.h"

#define MODULO_TWO_SUM( arg1, arg2, arg3)	( arg1 ^ arg2 ^ arg3 )
static const  uint16_t index_calc[16] =
{
	0, 52225, 55297, 5120, 61441, 15360, 10240, 58369,
	40961, 27648, 30720 , 46081, 20480, 39937, 34817, 17408
};

static uint8_t pageBuffer[PAGE_SIZE];
unsigned char CRC_HI,CRC_LO;
// հèè
#define BLOCKSIZE PAGE_SIZE
#define RECEIVED_DATA_SIZE		8

/* O荞ϸہB޲ˑłB */
#define INITIALIZE_UART_EXTERNAL_INTERRUPT()	(EICRA |= (1<<ISC01))	//< INT0̉~[荞݂𐶐悤ɐݒ
#define ENABLE_EXTERNAL_INTERRUPT()				(EIMSK |= (1<<INT0))

unsigned char BlockLoad (unsigned int size, unsigned char mem);
void UpdatePage (uint16_t, unsigned char erase); 
void UpdateEEPROM (uint16_t, uint16_t); 
void Write_EEPROM_byte (uint8_t addr, unsigned char cValue);
void Read_EEPROM_byte (uint8_t addr, unsigned char *cValue);
void Erase_One_Page (uint16_t addr);
void ProcessPageErase (void);
void wait_spm (void);
void CleanupAndRunApplication (unsigned int address);
void Disable_WatchDogTimer (void);
void ProcessCRCCheck (unsigned char mem, uint16_t endaddress);
void system_reset (void);

/*! \brief JԂ
 *
 * ͎Mް̔z񂪈tɂȂ邩A܂CR($0D)M܂ް
 * MwhileJԂ܂݂܂BĎMް𑗂ԂĎJԂ
 * B
 */
void main (void)
{
	unsigned char val = 0;
	uint16_t addr=0;
	uint16_t eeprom_addr = 0;
	uint8_t temp_int = 0;
	unsigned char command_char=0;

	CLKPR = (1<<CLKPCE);							// 4MHz  ۯݒ
	CLKPR = 0x01;
	__disable_interrupt();							// S̊荞݋֎~
	Read_EEPROM_byte(EEMEM_ADDR_AVERSION, &val);	// ް ׸ޒl擾
	Disable_WatchDogTimer();						// ޯ ϋ֎~

	if(val == BOOT_FLAG)							// ް۰ޓŁA
	{
		SW_UART_Enable();							// ĳUARTײދ
		__disable_interrupt();						// S̊荞݋֎~

		for(;;)										// ȉJԂ
		{
			val = recchar();						// ߕ҂(ߎ󂯎҂)

			if( val == 'C')
			{
				addr = (recchar()<<8) | recchar();
				ProcessCRCCheck('f',addr);
				sendchar(CRC_HI);
				sendchar(CRC_LO);
			}
			else if( val == 'D')
			{
				addr = (recchar()<<8) | recchar();
				ProcessCRCCheck('e', addr);
				sendchar(CRC_HI);
				sendchar(CRC_LO);
			}
			else if(val == 'E')
			{
				sendchar('\r');
			}

			else if( val == 'r')					// {޲ēǂݍ݁˖ߎs
			{
				if( command_char == 'a' )
				{
					sendchar( BVERSION );
				}
				else if(command_char == 'b')		// MCUx~ɒu
				{
					sendchar('Y');
					// O荞ݍ\ݒ
					INITIALIZE_UART_EXTERNAL_INTERRUPT();
					ENABLE_EXTERNAL_INTERRUPT();
					__enable_interrupt();			// S̊荞݋
					// ܰދx~ֈڍs
					SMCR |= ((1<<SM1)|(1<<SM0));
					SMCR |= (1<<SE);
					__sleep();
					__disable_interrupt();			// S̊荞݋֎~
				}
				else								// PɊ֐߲ق邽߂ɒǉB̂悤Ȗ߂͂ɂ܂B
					sendchar(0xFF);
			}

			else if( val == 'l')					// {޲ď݁˖ߐݒ
			{
				command_char = recchar();
				sendchar('\r');
			}

			else if(val=='A')						// ڽݒ
			{	// :ׯ ؂̱ڽ޲Ăł͂ȂPʂłB
				addr =(recchar()<<8) | recchar();	// ڽ̏ʂƉʂ޲Ă󂯎
				eeprom_addr = addr;					// EEPROMp̏ꍇ̱ڽۑ
				addr = addr<<1;
				sendchar('\r');						// OK𑗂Ԃ
			}

			else if(val == 'e' )					// ߏ
			{
				wait_spm();
				ProcessPageErase();
				sendchar('\r');						// OK𑗂Ԃ
			}

			else  if(val == 'B' )					// ݒJn
			{
				temp_int = (recchar()<<8) | recchar();	// eʎ擾
				val = recchar();						// ،`擾
				for (uint8_t i = 0; i < temp_int; ++i)
				{
					pageBuffer[i] = recchar();
				}
				wait_spm();
				if(val =='F')						// ׯXVA͂UpdatePage֐ő܂B
					UpdatePage(addr, 0);
				else if(val=='E')					// EEPROMXV
				{
					UpdateEEPROM(eeprom_addr,temp_int);
					sendchar('\r');
				}
//				sendchar('\r');
			}

			else if(val == 'V' )					// ps
			{
				Write_EEPROM_byte(EEMEM_ADDR_AVERSION, 0x00);
				system_reset();
			}

			else if(val != 0x1b)					// ESCł΂΁AF
				sendchar('?');
		}
	}
	else
	{
		CleanupAndRunApplication((CSTARTUP_ADDRESS));
	}
}

void wait_spm (void)
{
	do{} while ((SPMCSR & (1 << SELFPROGEN)) != 0);	// SPM슮҂
}

void ProcessPageErase (void)
{
	uint16_t addr = 0;
	uint8_t i;

	for (i = 0; i < PAGE_SIZE; ++i)
	{
		pageBuffer[i] = 0xFF;
	}

	UpdatePage (addr, 1);							// ؾ ޸
	addr += PAGE_SIZE;

	for (i = 0; i < (LAST_PAGE_NO_TO_BE_ERASED - 1); i++, addr += PAGE_SIZE)
	{
		addr &= ~(PAGE_SIZE - 1);

		if (addr < BOOT_PAGE_ADDRESS)
			Erase_One_Page (addr);					// ް۰ޗ̈܂1e߰ނ
	}
	wait_spm();
}

/***********************************************************************/
/* Ζ߰ޏA̋E							   */
void Erase_One_Page (uint16_t addr)
{
	// ^ꂽڽ߰ނ
	_SPM_ERASE (addr);
	wait_spm();
}
/***********************************************************************/
/***********************************************************************/
void UpdateEEPROM (uint16_t pageAddress, uint16_t size)
{
	unsigned char addr = 0;
	uint8_t tempaddress = 0;

	// ؂256޲ĂȂ̂ŁA16ޯ ڽ̏޲Ă͏0łׂłB
	if(pageAddress&0xFF00 != 0)
		return;
	addr = (unsigned char)(pageAddress);

	wait_spm();
	for( tempaddress=0; tempaddress < size; tempaddress++)
	{
		if(addr == 0xFF)							// ZƐƎ҂ްی
			break;
		EEAR = addr;								// EEPROMڽ\ݒ
		EEDR = pageBuffer[tempaddress];				// ް ޲Ď擾/ݒ
		EECR |= (1<<EEMPE);							// ޲ď
		EECR |= (1<<EEPE);
		while (EECR & (1<<EEPE));					// ݑ슮҂

		addr++;										// EEPROM޲ĈʒuI
	}
}

/***********************************************************************/
void UpdatePage (uint16_t pageAddress, unsigned char erase)
{
	// ߰ ڽ ޯĈȊOՕ
	pageAddress &= ~(PAGE_SIZE - 1);
	// ꂪ߰0ȂARESET޸ی
	if (pageAddress == INTVECT_PAGE_ADDRESS)
	{
		// RESETƑ޸̓eɏՕɐݒ
		pageBuffer[0] =
		__load_program_memory ((void __flash *) (INTVECT_PAGE_ADDRESS + 0));
		pageBuffer[1] =
		__load_program_memory ((void __flash *) (INTVECT_PAGE_ADDRESS + 1));
		pageBuffer[2] =
		__load_program_memory ((void __flash *) (INTVECT_PAGE_ADDRESS + 2));
		pageBuffer[3] =
		__load_program_memory ((void __flash *) (INTVECT_PAGE_ADDRESS + 3));
	}

	// ްė̈XVǂ݂̎
	if (pageAddress < BOOT_PAGE_ADDRESS)
	{
		Erase_One_Page (pageAddress);

		// ꎞ߰ފɏՕݒ
		uint8_t *bufferPtr = pageBuffer;
		uint16_t tempAddress = pageAddress;
		for (uint8_t i = 0; i < PAGE_SIZE; i += 2)
		{
			uint16_t tempWord = ((bufferPtr[1] << 8) | bufferPtr[0]);
			_SPM_FILLTEMP (tempAddress, tempWord);	// ^ꂽްňꎞɏՕ𖞂B
			tempAddress += 2;
			bufferPtr += 2;
		}

		// ꎞɏՕ^ꂽׯ ؂̈ʒu߰ޏ
		_SPM_PAGEWRITE (pageAddress);
		if(erase == 1)
		{
			wait_spm();
		}
		else
			sendchar('\r');
//		wait_spm();
	}
}

/***********************************************************************/
/***********************************************************************/
void Read_EEPROM_byte (uint8_t addr, unsigned char *cValue)
{
	while (EECR & (1 << EEPE));		// (Ô)EEPROM݊҂
	EEAR = addr;					// EEPROMڽݒ
	EECR = (1 << EERE);				// ǂݍ݋
	*cValue = EEDR;					// EEPROMްǂݍ/ۑ
}
void Write_EEPROM_byte (uint8_t addr, unsigned char cValue)
{
	while (EECR & (1 << EEPE));		// (Ô)EEPROM݊҂
	EEAR = addr;					// EEPROMڽݒ
	EEDR = cValue;					// ޲ ްݒ
	EECR |= (1<<EEMPE);				// ݊Jn
	EECR |= (1<<EEPE);
	while (EECR & (1<<EEPE));		// EEPROM݊҂
}

void CleanupAndRunApplication (unsigned int address)
{
	void (*FuncPtr) (void) = (void (*)(void)) ( address/ 2);	// Ō̊荞޸̱ڽɊ֐߲\ݒ
	FuncPtr ();
}

/***********************************************************************/

void Disable_WatchDogTimer (void)
{
	__watchdog_reset();
	MCUSR &= ~(1<<WDRF);			// MCUSRWDRF(0)
	WDTCSR |= (1<<WDCE) | (1<<WDE);	// WDTύX(WDCE=WDE=1)AӐ}ʎԌo߂h߂ɋOuݒێ
	WDTCSR = 0x00;					// WDT~
}

/***********************************************************************/
void ProcessCRCCheck (unsigned char mem, uint16_t endaddress)
{
	uint16_t crc_sum=0;
	uint16_t j=0;
	uint16_t i;
	uint8_t data = 0;
	if(mem == 'f')
	{
		i = 0x4;					// CRCɑ΂ؾ ޸\O
		while (i <= endaddress)
		{
			data = __load_program_memory((void __flash *)(i));
			j=index_calc[crc_sum & 0xF];
			crc_sum = (crc_sum >> 4) & 0x0FFF;
			crc_sum = MODULO_TWO_SUM(crc_sum, j, index_calc[data & 0xF]);

			j= index_calc[crc_sum & 0xF];
			crc_sum = (crc_sum >> 4) & 0x0FFF;
			crc_sum = MODULO_TWO_SUM( crc_sum, j, index_calc[(data >> 4) & 0xF]);
			i++;
		}
	}
	else if(mem == 'e')
	{
		i = 0x00;
		while (i <= endaddress )
		{
			Read_EEPROM_byte(i,&data);
			j=index_calc[crc_sum & 0xF];
			crc_sum = (crc_sum >> 4) & 0x0FFF;
			crc_sum = MODULO_TWO_SUM(crc_sum, j, index_calc[data & 0xF]);

			j= index_calc[crc_sum & 0xF];
			crc_sum = (crc_sum >> 4) & 0x0FFF;
			crc_sum = MODULO_TWO_SUM( crc_sum, j, index_calc[(data >> 4) & 0xF]);

			i++;
		}
	}
	CRC_HI = 0x00FF & (crc_sum >> 8);
	CRC_LO = crc_sum & 0x00FF;
}

void system_reset (void)
{
	uint8_t temp;

	/* ޯލ\ݒ */
	temp = (1<<WDIF)|(0<<WDIE)|(0<<WDCE)|(1<<WDE )|			//  ؾēųޯ ϋ
		   (0<<WDP3) | (0<<WDP2) | (0<<WDP1) | (0<<WDP0);	// 16msԊu
	WDTCSR  = (1<<WDCE)|(1<<WDE);		// WDTύX
	WDTCSR  = temp;
	WDTCSR |= (1<<WDE);
	while(1);							// 4MHzősMCU
}